<?php

# File: SP_expand.php  Updated April 6th, 2017
# Author: Eoin Fahy
#
# Copyright (C) 2006-2014. The Regents of the University of California. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 3. Neither the name of the LIPID MAPS (TM) consortium nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The LIPID MAPS (TM) consortium is a multi-institutional multi-year effort
# involved in identification and characterization of existing and novel lipids,
# quantifications of changes in their metabolites, and development of biochemical
# pathways and interaction network maps involving lipids. Please acknowledge use
# of the LIPID MAPS (TM) Tools in your work by citing appropriate literature
# references. For further details, please visit www.lipidmaps.org.
#
# Support for this effort is provided by  by National Institutes of Health (NIH)
# and National Institute of General Medical Sciences (NIGMS) Glue Grant
# NIH/NIGMS Grant 1 U54 GM69338.
#
#USAGE: php SP_expand.php <none|chains> <ion type>
#USAGE: Permitted ion type : M.,M+H,M+2H,M+3H,M+4H,M-H,M-2H,M-3H,M-4H,M+NH4,M+Ag,M+Na,M+2Na,M+K,M+2K,M+Li,M+2Li,M.Cl,M.OAc,M-DFPU+NH4,M-diDFPU+NH4
#USAGE: ion types correspond to: [M.]+,[M+H]+,[M+2H]2+,[M+3H]3+,[M+4H]4+,[M-H]-,[M-2H]2-,[M-3H]3-,[M-4H]4-,[M+NH4]+,[M+Ag]+,[M+Na]+,[M+2Na]2+,[M+K]+,[M+2K]2+,[M+Li]+,[M+2Li]2+,[M+Cl]-,[M+OAc]-,[M-DFPU+NH4]+,[M-diDFPU+NH4]+
#Example: php SP_expand.php > SP.txt (neutral molecule mass calculation,individual chains are not specified)
#Example: php SP_expand.php chains > SP.txt (neutral molecule mass calculation,individual chains are specified)
#Example: php SP_expand.php none M+H > SP.txt ([M+H]+ ion mass calculation,individual chains are not specified)
#Example Save to file: php SP_expand.php > SP.txt

$chains = isset($argv[1]) ? $argv[1] : '';
$ion = isset($argv[2]) ? $argv[2] : '';

$sub_exactmass= 0; 
$theion='';
$mult_factor=1;
$sn1listx='';
include("ioncalc.php");
##############################SPECIFY CHAINS AND HEADGROUPS#################################
$hgArray=array('Cer','SM','CerP','HexCer');


$sn1list='
m14:0
m14:1
d14:1
d14:0
d14:2
t14:0
t14:1
m15:0
m15:1
d15:1
d15:0
d15:2
t15:0
t15:1
m16:0
m16:1
d16:1
d16:0
d16:2
t16:0
t16:1
m17:0
m17:1
d17:1
d17:0
d17:2
t17:0
t17:1
m18:0
m18:1
d18:1
d18:0
d18:2
t18:0
t18:1
m19:0
m19:1
d19:1
d19:0
d19:2
t19:0
t19:1
m20:0
m20:1
d20:1
d20:0
d20:2
t20:0
t20:1
m21:0
m21:1
d21:1
d21:0
d21:2
t21:0
t21:1
m22:0
m22:1
d22:1
d22:0
d22:2
t22:0
t22:1
';

$sn2list='
0:0
12:0
13:0
14:0
14:0h
15:0
15:0h
16:0
16:1
16:0h
16:1h
17:0
17:0h
18:0
18:1
18:0h
18:1h
19:0
19:0h
20:0
20:1
20:0h
20:1h
21:0
21:0h
22:0
22:1
22:0h
22:1h
23:0
23:0h
24:0
24:1
24:0h
24:1h
25:0
25:0h
26:0
26:1
26:0h
26:1h
27:0
27:0h
28:0
28:0h
29:0
29:0h
30:0
30:0h
31:0
31:0h
32:0
32:0h
33:0
33:0h
34:0
34:0h
';


$headfile = array(
'Cer' => '0,1,0,0,0',
'SM' => '5,13,1,3,1',
'CerP' => '0,2,0,3,1',
'CerPEtn' => '2,7,1,3,1',
'CerPIns' => '6,12,0,8,1',
'HexCer' => '6,11,0,5,0',
'GlcCer' => '6,11,0,5,0',
'GalCer' => '6,11,0,5,0',
'LacCer' => '12,21,0,10,0',
'GM3Cer'=> '23,38,1,18,0',
'GM4Cer'=> '17,28,1,13,0',
'GB3Cer'=> '18,31,0,5,0',
'iGB3Cer'=> '18,31,0,5,0',
'asialo-GM2Cer'=> '20,34,1,15,0',
'Lc3Cer'=> '20,34,1,15,0',
'Manb1-4GlcCer'=> '12,21,0,10,0',
'MolluCer'=> '18,31,0,15,0',
'ArthroCer'=> '20,34,1,15,0'
);


$SP1_list=explode("\n",$sn1list);
$SP2_list=explode("\n",$sn2list);

$uniq=array();


for($i = 0; $i < count($hgArray); $i++) {
	for($j = 0; $j < count($SP1_list); $j++) {
		for($k = 0; $k < count($SP2_list); $k++) {
		
$HG_elements = explode(",",$headfile{$hgArray[$i]});


$full_abbrev="$hgArray[$i]". "(" . "$SP1_list[$j]" . "/" . "$SP2_list[$k]" .")";
$SP_abbrev="$SP1_list[$j]" . "/" . "$SP2_list[$k]";

$numC = 0;
$numH = 0;
$numO = 0;
$numN = 0;
$numP = 0;
$numNa = 0;
$numK = 0;
$numCl = 0;
$numAg = 0;
$numF = 0;
$numS = 0;
$numLi = 0;

$numacylC = 0;
$numacylH = 0;
$numacylO = 0;

$numDB = 0;

$CHAINTYPE='';
$LCBTYPE='';
$oxidation_flag='';
if(preg_match("/^d/" , $SP1_list[$j])){
$numacylO += 2;
$LCBTYPE='d';
$sn1listx=preg_replace("/^d/","",$SP1_list[$j]);
}
elseif(preg_match("/^t/" , $SP1_list[$j])){
$numacylO += 3;
$LCBTYPE='t';
$sn1listx=preg_replace("/^t/","",$SP1_list[$j]);
}                    
elseif(preg_match("/^m/" , $SP1_list[$j])){
$numacylO ++;
$LCBTYPE='m';
$sn1listx=preg_replace("/^m/","",$SP1_list[$j]);
}                    

if($sn1listx){$sp2Array = explode(":",$sn1listx);} else{$sp2Array=array(0,0);}
if($SP2_list[$k]){$sp3Array = explode(":",$SP2_list[$k]);} else{$sp3Array=array(0,0);}

if(preg_match("/h/",$SP2_list[$k])){
$numacylO += 1;
$sp3Array[1]=preg_replace("/h/","",$sp3Array[1]);
$CHAINTYPE='h';
}                                          

		if($sp2Array[0] > 0){
$numacylC += $sp2Array[0];
$numacylH += (($sp2Array[0]) * 2) - ($sp2Array[1] * 2)+1;
}                    


		if($sp3Array[0] > 0){
$numacylC += $sp3Array[0];
$numacylO += 1;
$numacylH += (($sp3Array[0] - 1) * 2) - ($sp3Array[1] * 2)+1;
}  

if($SP2_list[$k] == '0:0'){
$numacylH++; #deal with Lyso
}

$numC = $numacylC + $HG_elements[0];
$numH = $numacylH + $HG_elements[1];
$numN = 1+ $HG_elements[2];
$numO = $numacylO + $HG_elements[3];
$numP = $HG_elements[4];
$numDB = $sp2Array[1] + $sp3Array[1];

$SP_mass = $mult_factor * ($sub_exactmass + ($numC * 12) + ($numH * 1.007825) + ($numO * 15.994915) + ($numN * 14.003074) + ($numP * 30.973763));
$SP_mass = sprintf('%0.4f',$SP_mass);                   
$SP_mass6 = ($numC * 12) + ($numH * 1.007825) + ($numO * 15.994915) + ($numN * 14.003074) + ($numP * 30.973763);
$SP_mass6 = sprintf('%0.6f',$SP_mass6);                   
$numC6=$numC; $numH6=$numH; $numO6=$numO; $numN6=$numN; $numP6=$numP; $numS6=$numS; $numF6=$numF;

include("ioncalc2.php");

$nominal_mass=floor($SP_mass);

$formula=preg_replace("/([A-Za-z])1$/","$1",$formula);
$formula=preg_replace("/([A-Za-z]+)1([A-Za-z]+)/","$1$2",$formula);
 
if($SP1_list[$j] && $SP2_list[$k]){


if($chains == 'chains'){
print "$nominal_mass\t$SP_mass\t$full_abbrev\t$hgArray[$i]\t$numacylC\t$numDB\t$CHAINTYPE\t$formula\t$theion\n";
}
else{
$full_abbrev_bulk="$hgArray[$i]($LCBTYPE$numacylC:$numDB$CHAINTYPE)";
if(!in_array($full_abbrev_bulk,$uniq)){
array_push($uniq,$full_abbrev_bulk);
print "$nominal_mass\t$SP_mass\t$full_abbrev_bulk\t$hgArray[$i]\t$numacylC\t$numDB\t$CHAINTYPE\t$formula\t$theion\n";
}
}
}


		}
	}
}
?>
